{
#########################################################################
#  This software is open source, licensed under the GNU General Public
#  License, version 2.
#  Basically, this means that you're allowed to modify and distribute
#  this software. However, if you distribute modified versions, you MUST
#  also distribute the source code.
#  See http://www.gnu.org/licenses/gpl.html for the full license.
#########################################################################}

unit viewer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, math, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    ScrollBox1: TScrollBox;
    PaintBox1: TPaintBox;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  MIm: TBitmap;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 MIm:=TBitmap.Create;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 MIm.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 f: file;
 c: Char;
 i,j: integer;
 Mwidth,Mheigh:Integer;
begin
 if not OpenDialog1.Execute then Exit;

 if ExtractFileExt(OpenDialog1.FileName) = '.bmp' then begin
  MIm.LoadFromFile(OpenDialog1.FileName);
  PaintBox1.Width:=MIm.Width;
  PaintBox1.Height:=MIm.Height;
  Exit;
 end;

 AssignFile(f, OpenDialog1.FileName);
 Reset(f, 1);

 {   }
 Try
  BlockRead(f, c, SizeOf(c)); //  - 
 Except
  Exit;
 end;
 Mwidth := Ord(c);
 BlockRead(f, c, SizeOf(c)); //  - 
 Mwidth := Mwidth + Ord(c)*256;

 BlockRead(f, c, SizeOf(c));
 Mheigh := Ord(c);
 BlockRead(f, c, SizeOf(c));
 Mheigh := Mheigh + Ord(c)*256;

 PaintBox1.Width:=Mwidth;
 PaintBox1.Height:=Mheigh;

 //ShowMessage(IntToStr(Mwidth)+' '+IntToStr(Mheigh));
 Caption:='MapViewer - '+ExtractFileName(OpenDialog1.FileName)+' - '+IntToStr(Mwidth)+''+IntToStr(Mheigh);

 {      }
 with MIm do begin
  MIm.Width:=Mwidth;
  MIm.Height:=Mheigh;
  for j := Mheigh - 1 downto 0 do
   for i := 0 to Mwidth - 1 do begin
    BlockRead(f, c, SizeOf(c));
    case Ord(c) of                {b_g_r_}
     0: MIm.Canvas.Pixels[i,j]:=$00e9fafa;  //walkable block
     1: MIm.Canvas.Pixels[i,j]:=$00000000;  //non-walkable block
     2: MIm.Canvas.Pixels[i,j]:=$00ff6c6c;  //non-walkable water (not snipable)
     3: MIm.Canvas.Pixels[i,j]:=$00ce9b9b;  //walkable water
     4: MIm.Canvas.Pixels[i,j]:=$00966060;  //non-walkable water (snipable)
     5: MIm.Canvas.Pixels[i,j]:=$008c8cc8;  //cliff (snipable)
     6: MIm.Canvas.Pixels[i,j]:=$00808080;  //cliff (not snipable)
     else
        MIm.Canvas.Pixels[i,j]:=$00600000;  //unknown
    end;
   end;
 end;
 CloseFile(f);

 PaintBox1Paint(nil);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  f: file;
  c: Char;
  i,j,koef: integer;
begin
 if not SaveDialog1.Execute then Exit;
 case SaveDialog1.FilterIndex of
  1: MIm.SaveToFile(SaveDialog1.FileName+'.bmp');
  2: begin
   AssignFile(f, SaveDialog1.FileName+'.fld');
   Rewrite(f, 1);

   {  }
   koef:=MIm.Width div 256;
   c:=Chr(MIm.Width-koef*256);
   BlockWrite(f, c, SizeOf(c));
   c:=Chr(koef);
   BlockWrite(f, c, SizeOf(c));

   koef:=Mim.Height div 256;
   c:=Chr(MIm.Height-koef*256);
   BlockWrite(f, c, SizeOf(c));
   c:=Chr(koef);
   BlockWrite(f, c, SizeOf(c));


   {   }
   for j := MIm.Height - 1 downto 0 do
    for i := 0 to MIm.Width - 1 do begin
     case MIm.Canvas.Pixels[i,j] of
      $00e9fafa: c:=Chr(0);
      $00000000: c:=Chr(1);
      $00ff6c6c: c:=Chr(2);
      $00ce9b9b: c:=Chr(3);
      $00966060: c:=Chr(4);
      $008c8cc8: c:=Chr(5);
      $00808080: c:=Chr(6);
     end;
     BlockWrite(f, c, SizeOf(c));
    end;
   CloseFile(f);
  end;
 end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 {     }
 PaintBox1.Canvas.Draw(0,0,MIm);
end;

end.
